<template>
    <div class="content-box-tittle" v-show="hasStartedSessionBuilder">
        <form class="form-material " data-vv-scope="form-1">
            <div class="form-group row">
                <div class="col-sm-4">
                    <input type="name" name="session_name" class="form-control form-control-lg" id="input" placeholder="Nombre de la sesión" v-model="name" @blur="changeSessionName" v-validate="'required|max:30|min:4'">
                    <span v-show="errors.has('form-1.session_name')" class="form-control-feedback danger-message">Ingresa un nombre entre 4 y 30 caracteres.</span>
                </div>
                <div class="col-sm-1">
                    <span class="tag tag-pill" :class="percentageCompleted == 100 ? 'tag-complete' : percentageCompleted == 0 ? 'tag-empty' : 'tag-incomplete' ">{{ `${percentageCompleted.toString().slice(0, 4)}` }}%</span>
                </div>
                <div class="col-sm-2">
                    <select class="form-control  mb-1 " placeholder="Semana" v-model="week" @change="changeSessionWeek">
                        <option :value="index" v-for="(week, index) in courseBuilderWeeks" :key="index">{{ `Semana ${index + 1 }` }}</option>
                    </select>
                </div>
                <div class="col-sm-1">
                    <button type="button" class="ml-2 btn btn-sm btn-circle waves-effect waves-light pull-right" data-toggle="modal" data-target=".default-modal3">
                        <i class="ti-plus"></i>
                    </button>

                    <div class="modal animated bounceInUp  default-modal3" id="weekModal" tabindex="-1" role="dialog" aria-labelledby="mySmallModalLabel" aria-hidden="true">
                        <div class="modal-dialog modal-sm">
                            <div class="modal-content">
                                <div class="modal-header">
                                    <button type="button" class="close" data-dismiss="modal" aria-label="Close">
                                        <span aria-hidden="true">×</span>
                                    </button>
                                    <h4 class="modal-title" id="mySmallModalLabel">Nueva Semana</h4>
                                </div>
                                <div class="modal-body ">
                                    <form class="form-material" data-vv-scope="form-2">
                                        <div class="form-group row">

                                            <div class="col-sm-12">
                                                <label class="mt-2"> Semana {{ courseBuilderWeeks.length + 1 }}</label>
                                                <input type="text" name="week" class="form-control form-control-lg" id="input" placeholder="Descripción de semana" v-model="weekName" v-validate="'required|max:30|min:4'">

                                                <span v-show="errors.has('form-2.week')" class="form-control-feedback danger-message">Ingresa un nombre entre 4 y 30 caracteres.</span>
                                            </div>

                                        </div>
                                    </form>
                                </div>
                                <div class="modal-footer">
                                    <button type="button" class="btn btn-danger" data-dismiss="modal" @click.prevent="clearNewWeek">Cancelar</button>
                                    <button :disabled="errors.has('form-2.week')" @click.prevent="createNewWeek('form-2')" class="btn btn-info" data-dismiss="modal">Crear</button>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="col-sm-2">
                    <select class="form-control  mb-1 " placeholder="Semana" v-model="sessionType" @change="changeSessionType">
                        <option value="content">Sesión</option>
                        <option value="quiz">Cuestionario</option>
                        <option value="eval">Evaluación</option>
                    </select>
                </div>
					<div class="col-sm-2" id="reading-time" v-if="sessionType == 'quiz' || sessionType == 'eval'">
						<i class="ti-timer" data-toggle="tooltip" data-placement="top" title="" data-original-title="Tiempo de evaluación en seg."></i>
						<input type="number" min="0" max="25" name="evalTime" id="input" placeholder="T. Lectura" class="form-control " v-validate="'required'" @blur="changeEvalTime" v-model="evalTime" aria-required="true" aria-invalid="false"> 
						<span v-show="errors.has('form-1.evalTime')" class="form-control-feedback danger-message">Este campo es requerido.</span>
					</div>
            </div>

            <div class="col-lg-12 content-option">
                <h4 class="pull-left"></h4>
                <button type="button" class="ml-2 btn btn-info btn-circle waves-effect waves-light pull-right" data-toggle="tooltip" data-placement="top" title="" data-original-title="Guardar sesión" @click.prevent="saveSession('form-1')" :disabled="canBeSaved">
                    <i class="ti-check "></i>
                </button>
                <button type="button" class="ml-2 btn btn-info btn-circle waves-effect waves-light pull-right" data-toggle="tooltip" data-placement="top" title="" data-original-title="Cancelar edición" @click.prevent="confirm('confirmCancel')">
                    <i class="ti-arrow-left"></i>
                </button>
                <button type="button" class="ml-2 btn btn-danger btn-circle waves-effect waves-light pull-right" data-toggle="tooltip" data-placement="top" title="" data-original-title="Eliminar sesión" @click.prevent="confirm('confirmDelete')">
                    <i class="ti-close"></i>
                </button>
            </div>
        </form>
    </div>
</template>
<script>

import ComponentTypes               from '../../../utils/ComponentTypes'
import { mapGetters, mapActions }   from 'vuex'

export default {

	components: {
    },
    data() {
        return {
            MINIMUM_PERCENTAGE_TO_SAVE : 60,
            name: '',
            week: 0,
            weekName: '',
            sessionType: 'content',
            evalTime: 20
        }
    },
    computed: {
        canBeSaved() {
            return this.errors.has('form-1.session_name') || this.courseBuilderList.length == 0 || !this.formIsValid
        },
        formIsValid() {
            return this.percentageCompleted >= this.MINIMUM_PERCENTAGE_TO_SAVE
        },
        percentageCompleted() {
            let lengthcount = 0
            let completecount = 0
            this.courseBuilderList.forEach(elem => {
                Object.entries(elem.value).forEach( (el, i) => {
                  if (typeof (el[1]) == "string" ) {
                      if(el[0] != 'notes' && el[0] != 'answer'){
                            lengthcount++
                            if(el[0] == 'img'){
                                lengthcount++
                            }
                            if(el[1].length > 0 && el[0] != 'img'){
                                completecount++
                            }
                            if(el[0] == 'imgType'){
                                if(el[1] == 'reference'){
                                    completecount++
                                }
                                if(el[1] == 'final'){
                                    completecount++
                                    completecount++
                                }
                            }
                      }
                    }
                  else if (typeof (el[1]) == "number") {
                    lengthcount++
                
                        if(el[1].toString().length > 0){
                           completecount++
                        }
                    }
                  else if (Array.isArray(el[1])) {
                    if (Object.prototype.toString.call(el[1]) == "[object Array]"){ 
                        el[1].forEach(item => {

                            if(Object.prototype.toString.call(item) == "[object Array]"){
                                
                                lengthcount++
                                if(item.length > 0){
                                    completecount++
                                }
                            }

                            else if(Object.prototype.toString.call(item) == "[object Object]"){
                                if(item.value){
                                    Object.values(item.value).forEach( value => {
                                    lengthcount++
                                        if(value.length > 0){
                                            completecount++
                                        }
                                    })
                                } else {
                                    Object.values(item).forEach( value => {
                                        if( Object.prototype.toString.call(value) != "[object Object]"){
                                            lengthcount++
                                            if(value.length > 0){
                                                completecount++
                                            }
                                        }
                                    
                                    })
                                }
                                
                            }

                        
                        })    
                    }
                    }                    
                })
            })

            return completecount / lengthcount * 100 ? completecount / lengthcount * 100 : 0
        },
        ...mapGetters([
            'tempSessionName',
            'tempSessionType',
            'isEditing',
            'courseBuilderList',
            'courseBuilderWeeks',
            'currentSessionBuilderWeek',
            'hasStartedSessionBuilder'
        ])
    },
    methods: {
        saveSession(scope) {
            this.$validator.validateAll(scope).then((result) => {
                this.updateBuiltPercentage(this.percentageCompleted)
                if (result && this.courseBuilderList.length > 0 && this.formIsValid) {
                    if (this.isEditing) {
                        this.updateCurrentSession(this.week)
                        this.endEditing()
                    }
                    else {
                        this.changeCurrentSessionWeek(this.week)
                        this.pushCurrentSession()
                    }
                    this.endBuilding()
                    toastr.success(`Se guardó exitosamente la sesión ${this.name}`, '¡Registro exitoso!')
                    this.name = ''
                    this.sessionType = 'content'
                }
            });
        },
        confirm(type) {
            this.displayModal(type)
        },
        showError(msg) {
            toastr.error(msg, 'Oops')
        },
        clearNewWeek() {
            this.weekName = ''
        },
        createNewWeek(scope) {
            this.$validator.validateAll(scope).then((result) => {
                if (result) {
                    this.addNewWeek(this.weekName)
                    this.clearNewWeek()
                    $('#weekModal').modal('toggle')
                }
            });
        },
        changeSessionName() {
            this.changeCurrentSessionName(this.name)
        },
        changeSessionType() {
            this.changeCurrentSessionType(this.sessionType)
        },
        changeEvalTime() {
            this.changeCurrentEvalTime(this.evalTime)
        },
        changeSessionWeek() {
            this.changeTempSessionWeek(this.week)
        },
        ...mapActions([
            'endBuilding',
            'endEditing',
            'updateCurrentSession',
            'deleteCurrentSession',
            'deleteEditingSession',
            'storeCourse',
            'changeCurrentEvalTime',
            'changeCurrentSessionName',
            'changeCurrentSessionType',
            'changeCurrentSessionWeek',
            'changeTempSessionWeek',
            'pushCurrentSession',
            'addNewWeek',
            'updateBuiltPercentage',
			'displayModal',
        ]),
        storeData() {
            this.storeCourse(this.courseBuilderList)
        }
    },
    watch: {
        tempSessionName(val) {
            this.name = val
        },
        tempSessionType(val) {
            this.sessionType = val
        },
    }
}
</script>
